#include "uart.h"
#include "ddr_sdram.h"
//#include "sdram_detect.h"
#include "mem_test.h"
#include "xparameters.h"

#define SDRAM_DATA_WIDTH 64
#define SDRAM_ADDR_WIDTH 25
#define SDRAM_WORD_COUNT 33554432  - 0x5000 //67108864
#define SDRAM_MAX_OFFSET 0x07FFFFFF

static Xuint32 DDR_BaseAddress;


void sdramInit(Xuint32 sdram_address) {
  DDR_BaseAddress = sdram_address;
} // end sdramInit()


int main() {
  Xuint32 data_width = SDRAM_DATA_WIDTH;
  Xuint32 addr_width = SDRAM_ADDR_WIDTH;
  Xuint32 word_count = SDRAM_WORD_COUNT;
  Xuint32 max_offset = SDRAM_MAX_OFFSET;
  Xuint32 base_address, i;
  Xuint32 rank_count;

  print("\r\nTurning caches on");
  XCache_EnableDCache(0xF000000F); 
  XCache_EnableICache(0xF000000F);
   
  sdramInit(XPAR_DDR_256MB_32MX64_RANK1_ROW13_COL10_CL2_5_MEM0_BASEADDR);
  DDR_BaseAddress = DDR_BaseAddress + 0x5000;

  //clearScreen();

 
    base_address = DDR_BaseAddress;
    print("\r\nDDR SDRAM Test");
    print("\r\n----------------------\r\n");
    runDataTestL(base_address, data_width);
    runAddrTest(base_address, addr_width, max_offset);
    runDeviceTestL(base_address, word_count);
    runTestPatternRGB(655360);


  print("\r\nMemory test complete\r\n");
  

} // end sdramTest()
